# include <cstdio>
# include <vector>
# include <algorithm>
# include <iostream>


using namespace std;

struct point 
{
  int  x;
  int  y;
  point(int xx,int yy):x(xx),y(yy){}
};

struct wskaznik{
	point * p;
	p operator*(){
		return *p;
	}

	bool operator<(const wskaznik&w){
		return *p<*w;
	}

	void set(point*pp){p=pp;}
	//wskaznik(point pp):p(&pp)
}

point operator-(point &a, point &b)
{
  point p;
  p.x = a.x - b.x;
  p.y = a.y - b.y;
  return p;
}

int times(point a, point b)
{
  long long x = (long long)a.x*(long long)b.y - (long long)b.x*(long long)a.y;
  if (x > 0) 
    return 1;
  if (x < 0)
    return -1;
  return 0;
}

int  ccw(wskaznik p0,wskaznik p1, wskaznik p2)
{
  return times((*p2-*p0),(*p1-*p0));
}

int n;
wskaznik P[500003];
wskaznik Stos[500003];
int sp;

void push(wskaznik a)
{
  Stos[sp] = a;
  sp ++;
}

inline wskaznik top(void)
{
  return Stos[sp - 1];
}

inline wskaznik nttop(void)
{
  return Stos[sp - 2];
}


inline wskaznik pop() 
{
  sp--;
  return Stos[sp];
}
  
  

inline bool operator<(const point &a, const point &b)
  {
    int x =  ccw(*(P[0]), a, b);
    if (x < 0) 
      return true;
    return false;
}

inline bool operator>(const point &a, const point &b)
  {
    int x =  ccw(*(P[0]), a, b);
    if (x > 0) 
      return true;
    return false;
  }

inline bool operator==(const point &a, const point &b)
  {
    if (a.x == b.x) 
      if (a.y == b.y) 
	return true;
    return false;
}


void Graham(void)
{
  push(P[0]);
  push(P[1]);
  push(P[2]);
  for (int i = 3; i < n; i++)
    {
      while (ccw(nttop(), top(), P[i]) >= 0)
	pop();
      push(P[i]);
    }
}


inline long long  dist(wskaznik a,wskaznik  b)
{
  long long aa = (a->x - b->x);
  long long bb = (a->y - b->y);
  return aa*aa+bb*bb;
}

void Solve(void)
{
  long long  maxdist = 0;
  int i = 0;
  long long d1, d2;
  for (int q0 = 0; q0 < sp; q0 ++)
    {
#if 0
      d1 =dist(Stos[(i+1) % sp],Stos[q0]);
      d2 = dist(Stos[i % sp], Stos[q0]);
      while (d1 > d2) 
	{
	  i++;
	  d1 =dist(Stos[(i+1) % sp],Stos[q0]);
	}
      if (dist(Stos[(i) % sp],Stos[q0]) > maxdist)
	maxdist = dist(Stos[(i) % sp],Stos[q0]);
#endif
      d1 =dist(Stos[(i+1) % sp],Stos[q0]);
      d2 = dist(Stos[i % sp], Stos[q0]);
      while (d1 > d2) 
	{
	  i++;
	  d1 =dist(Stos[(i+1) % sp],Stos[q0]);
	}
      i--;
      if (dist(Stos[(i+1) % sp],Stos[q0]) > maxdist)
	maxdist = dist(Stos[(i+1) % sp],Stos[q0]);
    }
  cout << (long long)  maxdist << endl;
}



int main(void)
{
  int d;
  scanf("%d",&d);
  for(int i = 0; i < d; i++)
    {
      sp = 0;
      scanf("%d", &n);
      for(int j = 0; j < n; j++)
	{
	  scanf("%d", &P[j].y);
	  scanf("%d", &P[j].x);
	}

      if (n==2)
	{
	  cout << dist(P[0],P[1]) << endl;
	  continue;
	}
      sort(P+1,P+n);
      Graham();      
      /*            for (int k = 0; k < n; k++)
	printf("%d %d\n", P[k].x, P[k].y);
      printf("Wypukla otoczka\n");
      for (int k = 0; k < sp; k++)
      printf("%d %d\n", Stos[k].x, Stos[k].y);*/
      Solve();
    }
      
  return 0;
}
